{
    "root":          true,
    "env":           {
        "node":          true,
        "es6":           true,
        "webextensions": true
    },
    "extends":       [
        "plugin:vue/recommended"
    ],
    "globals":       {
        "Vue": "readonly"
    },
    "parserOptions": {
        "parser":      "babel-eslint",
        "ecmaVersion": 2020
    },
    "rules":         {
        "indent":                           [
            "error", 4, {
                "SwitchCase":             1,
                "MemberExpression":       "off",
                "flatTernaryExpressions": false,
                "ignoredNodes":           [
                    "ConditionalExpression"
                ]
            }
        ],
        "no-unused-vars":                   [
            "error", {
                "varsIgnorePattern": "key"
            }
        ],
        "no-console":                       "off",
        "no-empty":                         [
            "error", {
                "allowEmptyCatch": true
            }
        ],
        "no-var":                           "error",
        "no-new-object":                    "error",
        "object-shorthand":                 "error",
        "quote-props":                      ["error", "as-needed"],
        "no-array-constructor":             "error",
        "array-callback-return":            "error",
        "prefer-destructuring":             [
            "error", {
                "object": false,
                "array":  false
            }
        ],
        "quotes":                           [
            "error", "single", {
                "avoidEscape": true
            }
        ],
        "no-eval":                          "error",
        "no-useless-escape":                "error",
        "func-style":                       [
            "error", "expression", {
                "allowArrowFunctions": true
            }
        ],
        "wrap-iife":                        ["error", "outside"],
        "no-loop-func":                     "error",
        "no-new-func":                      "error",
        "space-before-function-paren":      [
            "error", {
                "anonymous":  "always",
                "named":      "never",
                "asyncArrow": "always"
            }
        ],
        "space-before-blocks":              "error",
        "prefer-spread":                    "error",
        "prefer-arrow-callback":            "error",
        "arrow-spacing":                    [
            "error", {
                "before": true,
                "after":  true
            }
        ],
        "arrow-parens":                     ["error", "always"],
        "multiline-ternary":                ["error", "always-multiline"],
        "no-confusing-arrow":               "off",
        "no-dupe-class-members":            "error",
        "no-iterator":                      "error",
        "dot-notation":                     "error",
        "no-undef":                         "error",
        "no-multi-assign":                  "error",
        "operator-linebreak":               [
            "error", "none", {
                "overrides": {
                    "?":   "ignore",
                    ":":   "ignore",
                    "||":  "ignore",
                    "!==": "ignore",
                    "===": "ignore",
                    "=":   "ignore"
                }
            }
        ],
        "no-func-assign":                   "error",
        "no-useless-call":                  "error",
        "no-useless-computed-key":          "error",
        "no-useless-constructor":           "error",
        "no-useless-rename":                "error",
        "no-useless-return":                "error",
        "eqeqeq":                           [
            "error", "always", {
                "null": "ignore"
            }
        ],
        "no-case-declarations":             "off",
        "no-nested-ternary":                "off",
        "no-unneeded-ternary":              "error",
        "nonblock-statement-body-position": ["error", "beside"],
        "brace-style":                      [
            "error", "1tbs", {
                "allowSingleLine": true
            }
        ],
        "spaced-comment":                   ["error", "always"],
        "no-multiple-empty-lines":          "error",
        "array-bracket-spacing":            ["error", "never"],
        "object-curly-spacing":             ["error", "always"],
        "eol-last":                         "error",
        "comma-spacing":                    [
            "error", {
                "before": false,
                "after":  true
            }
        ],
        "computed-property-spacing":        ["error", "never"],
        "func-call-spacing":                ["error", "never"],
        "no-trailing-spaces":               "error",
        "comma-style":                      ["error", "last"],
        "semi":                             ["error", "always"],
        "accessor-pairs":                   "error",
        "sort-imports":                     [
            "error", {
                "ignoreCase":            true,
                "ignoreDeclarationSort": true
            }
        ],
        "block-spacing":                    ["error", "always"],
        "vue/html-indent":                  "off",
        "vue/script-indent":                "off",
        "vue/max-attributes-per-line":      "off",
        "vue/require-default-prop":         "off",
        "vue/require-v-for-key":            "off",
        "vue/require-prop-types":           "off",
        "vue/valid-v-slot":                 "off",
        "vue/html-quotes":                  [
            "error", "double", {
                "avoidEscape": true
            }
        ],
        "comma-dangle":                     ["error", "always-multiline"],
        "arrow-body-style":                 [
            "error", "as-needed", {
                "requireReturnForObjectLiteral": true
            }
        ],
        "vue/html-closing-bracket-newline": "off",
        "vue/no-v-html":                    "off"
    },
    "overrides":     [
        {
            "files": [
                "**/__tests__/*.{j,t}s?(x)",
                "**/tests/unit/**/*.spec.{j,t}s?(x)"
            ],
            "env":   {
                "jest": true
            }
        },
        {
            "files": ["*.vue"],
            "rules": {
                "indent":                                      "off",
                "vue/html-quotes":                             [
                    "error", "double", {
                        "avoidEscape": true
                    }
                ],
                "vue/html-indent":                             "off",
                "vue/script-indent":                           "off",
                "vue/require-default-prop":                    "off",
                "vue/singleline-html-element-content-newline": "off",
                "vue/html-closing-bracket-newline":            "off",
                "vue/require-prop-types":                      "off",
                "vue/valid-v-slot":                            "off"
            }
        }
    ],
    "plugins":       [
        "vue"
    ]
}
